# common_utils.R
# For common or shared functions

# Split the last "_" to get name for chemical label and does unit
parse_column_info <- function(col_name) {
  column_info <- list(name = col_name, does_unit = NULL)
  
  if (regexpr("_", col_name)[[1]][1] > 0) {
    sub_values <- strsplit(stri_reverse(col_name), "_")[[1]]
    column_info$does_unit <- stri_reverse(sub_values[1])
    
    if (length(sub_values) == 2) {
      column_info$name <- stri_reverse(sub_values[2])
    } else if (length(sub_values) > 2) {
      column_info$name <- stri_reverse(paste(sub_values[-1], collapse ="_"))
    }
  }
  # else if (regexpr("-", col_name)[[1]][1] > 0) {
  #   sub_values <- strsplit(stri_reverse(col_name), "-")[[1]]
  #   column_info$does_unit <- stri_reverse(sub_values[1])
  #   
  #   if (length(sub_values) == 2) {
  #     column_info$name <- stri_reverse(sub_values[2])
  #   } else if (length(sub_values) > 2) {
  #     column_info$name <- stri_reverse(paste(sub_values[-1], collapse ="-"))
  #   }
  # }
  
  column_info
}

# Extract column information (from col_name <- "Ent_12.5uM" to ("Ent_12.5uM", "Ent", "12.5", "uM"))
match_column_info <- function(col_name) {
  column_info <- data.frame("column_name" = name_label, "chemical" = name_label, "short_label" = name_label, "concentration" = "", "concentration_unit" = "")
  pattern <- "(.+\\w)[_|-| ]+([\\.\\d]+)\\s*([[:alpha:]]+)$"
  matched <- regmatches(col_name, regexec(pattern, col_name, perl = TRUE))
  
  if (length(matched) == 1 && length(matched[[1]]) == 4) {
    values <- matched[[1]]
    values[1] <- values[2]
    column_info[1, ] <- c(col_name, values)
  }

  return (column_info)
}

create_plot_title <- function(column_info) {
  concentration_unit <- paste(column_info$concentration, column_info$concentration_unit, sep = "")
  title_plot <- paste(column_info$short_label, "at", concentration_unit, sep = " ")
  
  return (title_plot)
}

is_na_only <- function(values) {
  bools <-unique(is.na(values))
  
  return (length(bools) == 1 && bools == TRUE)
}
